unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, directshow9, ActiveX, UMemFile, BaseClass;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  KBPerSec: DWord = 0;
  mt: TAMMediaType;
  pmt: PAMMediaType;
  Mem: PByte;
  hr: HResult;
  Stream: TBCMemFileStream;
  Reader: TBCMemFileReader;
  ResHandle: THandle;// 
  MemHandle: THandle;//   
  ResSize: Longint;// 
  _FG: IGraphBuilder = nil;  //   
  _Pin: IPin = nil; // Pin  
  _MC: IMediaControl = nil; //  
  _VW: IVideoWindow = nil; //   

implementation

{$R *.dfm}
//   
{$R MyRes.RES}

procedure TForm1.FormCreate(Sender: TObject);
begin
// COM
   CoInitialize(nil);
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
//    
  pmt := @mt;
  TBCMediaType(pmt).InitMediaType;
  mt.majortype := MEDIATYPE_Stream;
  mt.subtype := MEDIASUBTYPE_Avi;
  //      Handle
  ResHandle := FindResource(hInstance, PChar(listbox1.Items.Strings[listbox1.ItemIndex]), PChar('AVI'));
  //        Handle
  MemHandle := LoadResource(hInstance, ResHandle);
  //        p
  mem := LockResource(MemHandle);
  //   
  ResSize := SizeOfResource(hInstance, ResHandle);

  //    source 
  Stream := TBCMemFileStream.Create(Mem, ResSize, KBPerSec);
  hr := S_OK;
  Reader := TBCMemFileReader.Create(Stream, pmt, hr);
  //  Make sure we don't accidentally go away!
  Reader._AddRef;

  (*   .     *)
//  
  if Assigned(_VW) then _VW := nil;
  if Assigned(_MC) then _MC := nil;
  if Assigned(_FG) then _FG := nil;

  //   
  hr := CoCreateInstance(CLSID_FilterGraph, nil, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, _FG);
  if Failed(hr) then
  begin
    showmessage('   ');
    Exit;
  end;

  //   
  hr := _FG.AddFilter(Reader, nil);
  if Failed(hr) then
  begin
    showmessage('  ');
    Exit;
  end;

  //   Pin
  _Pin := Reader.GetPin(0);
  //     Pin
  hr := _FG.Render(_Pin);
  if Failed(hr) then
   begin
    showmessage('   Pin');
    Exit;
  end;

   //   MediaControl   
  hr := _FG.QueryInterface(IID_IMediaControl, _MC);
  if Failed(hr) then
  begin
    showmessage('   MediaControl');
    Exit;
  end;

   //  VideoWindow   
   hr :=_FG.QueryInterface(IID_IVideoWindow, _VW);
   if Failed(hr) then
   begin
    showmessage('   VideoWindow');
    Exit;
   end;

 //    Panel1
 _VW.put_Owner(form1.Panel1.Handle);
 //  
 _VW.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
 //    
 _VW.SetWindowPosition(0, 0, form1.Panel1.ClientRect.Right,form1.Panel1.ClientRect.Bottom);
 //  
 hr := _MC.Run;
 if Failed(hr) then
 begin
    showmessage(' ');
    Exit;
 end;
(*   .*)

  // don't use Reader.Free !!!
  // The Reader will destroy itself if the Reference Count is 0
  Reader._Release;
  //    
  UnLockResource(MemHandle);
  //    
  FreeResource(MemHandle);
  FreeResource(ResHandle);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  
  if Assigned(_VW) then _VW := nil;
  if Assigned(_MC) then _MC := nil;
  if Assigned(_FG) then _FG := nil;

// OM
  CoUninitialize;
end;
end.

